
/*              Copyright 1993 Colorado State University                    */
/*                      All Rights Reserved                                 */

/*****************************************************************************
**
**  FILE:      ferr.c
**
**  FUNCTION:  void flow_err()
**
**  PURPOSE:   Handles errors generated by the flow functions.
**  
**  INPUTS:
**    error_num - indicator for error that has occurred
**    when      - when the error occurred in simulation
**
**  GLOBAL VARIABLES:
**    None
**
**  LOCAL VARIABLES:
**    err_msg - string containing error message   
**
**  OUTPUT:
**    None
**
**  CALLED BY:
**    flow()
**
**  CALLS:
**    None
**
*****************************************************************************/

#include <stdlib.h>
#include <stdio.h>
#include "flow.h"

    /* error messages */
    static char *err_msg[] = {
      "No Error.",                             /* 0 */
      "Stack Overflow",                        /* 1 */
      "Value of source variable is negative",  /* 2 */
      "Amount to flow has been limited",       /* 3 */
    };

    void flow_err(int error_num, float when)
    {
      fprintf(stderr,
              "\n Century flow error occurred at time = %10.4f\n%s\n\n",
              when, err_msg[error_num]);
      return;
    }
